Bug 612076 - Review Request: ghc-feldspar-language - Functional Embedded Language for DSP and PARallelism
Review Request: ghc-feldspar-language - Functional Embedded Language for DSP ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-07 05:26 EDT by Shakthi Kannan
Modified: 2012-01-23 08:02 EST (History)
4 users (show)

See Also:
Fixed In Version: ghc-feldspar-language-0.3.1-3.fc13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-11-24 17:40:32 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
petersen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
ghc-feldspar-language.spec-1.patch (1.38 KB, patch)
2010-11-15 04:37 EST, Jens Petersen
no flags Details | Diff

  None (edit)
Description Shakthi Kannan 2010-07-07 05:26:58 EDT
Spec URL: http://shakthimaan.fedorapeople.org/SPECS/ghc-feldspar-language.spec
SRPM URL: http://shakthimaan.fedorapeople.org/SRPMS/ghc-feldspar-language-0.3-1.fc13.src.rpm
Description: Feldspar is Functional Embedded Language for DSP and PARallelism. It is a functional language, specifically targeting digital signal processing (DSP) applications. It is implemented as an embedded language in Haskell, which means that it is really just a library of functions and types designed to give the feeling of a stand-alone language.
Comment 1 Shakthi Kannan 2010-07-07 05:35:10 EDT
Successful Koji builds for F-13, F-14 respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2299886
http://koji.fedoraproject.org/koji/taskinfo?taskID=2299889

$ rpmlint ghc-feldspar-language.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-feldspar-language-0.3-1.fc13.i686.rpm 
ghc-feldspar-language.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
ghc-feldspar-language.i686: W: unstripped-binary-or-object /usr/lib/ghc-6.12.1/feldspar-language-0.3/libHSfeldspar-language-0.3-ghc6.12.1.so
ghc-feldspar-language.i686: W: executable-stack /usr/lib/ghc-6.12.1/feldspar-language-0.3/libHSfeldspar-language-0.3-ghc6.12.1.so
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint ghc-feldspar-language-devel-0.3-1.fc13.i686.rpm 
ghc-feldspar-language-devel.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
ghc-feldspar-language-devel.i686: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint ghc-feldspar-language-doc-0.3-1.fc13.i686.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-feldspar-language-prof-0.3-1.fc13.i686.rpm 
ghc-feldspar-language-prof.i686: E: devel-dependency ghc-feldspar-language-devel
ghc-feldspar-language-prof.i686: W: no-documentation
ghc-feldspar-language-prof.i686: W: devel-file-in-non-devel-package /usr/lib/ghc-6.12.1/feldspar-language-0.3/libHSfeldspar-language-0.3_p.a
1 packages and 0 specfiles checked; 1 errors, 2 warnings.

$ rpmlint ghc-feldspar-language-0.3-1.fc13.src.rpm 
ghc-feldspar-language.src: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
Comment 2 Shakthi Kannan 2010-07-09 03:02:50 EDT
Updated to upstream 0.3.1:

SPEC: http://shakthimaan.fedorapeople.org/SPECS/ghc-feldspar-language.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/ghc-feldspar-language-0.3.1-1.fc13.src.rpm

Successful Koji builds for F-13, F-14 respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2308150
http://koji.fedoraproject.org/koji/taskinfo?taskID=2308153

$ rpmlint ghc-feldspar-language.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ../RPMS/i686/ghc-feldspar-language-0.3.1-1.fc13.i686.rpm 
ghc-feldspar-language.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
ghc-feldspar-language.i686: W: unstripped-binary-or-object /usr/lib/ghc-6.12.1/feldspar-language-0.3.1/libHSfeldspar-language-0.3.1-ghc6.12.1.so
ghc-feldspar-language.i686: W: executable-stack /usr/lib/ghc-6.12.1/feldspar-language-0.3.1/libHSfeldspar-language-0.3.1-ghc6.12.1.so
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint ../RPMS/i686/ghc-feldspar-language-doc-0.3.1-1.fc13.i686.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ../RPMS/i686/ghc-feldspar-language-devel-0.3.1-1.fc13.i686.rpm 
ghc-feldspar-language-devel.i686: W: spelling-error Summary(en_US) Haskell -> Harrell, Rathskeller, Hastily
ghc-feldspar-language-devel.i686: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint ../RPMS/i686/ghc-feldspar-language-prof-0.3.1-1.fc13.i686.rpm 
ghc-feldspar-language-prof.i686: E: devel-dependency ghc-feldspar-language-devel
ghc-feldspar-language-prof.i686: W: no-documentation
ghc-feldspar-language-prof.i686: W: devel-file-in-non-devel-package /usr/lib/ghc-6.12.1/feldspar-language-0.3.1/libHSfeldspar-language-0.3.1_p.a
1 packages and 0 specfiles checked; 1 errors, 2 warnings.
Comment 3 Jens Petersen 2010-08-31 03:40:52 EDT
I could review this if you able to review one of my pending submissions
(ghc-text is probably highest priority since it will block darcs-2.5
otherwise ghc-glib.)
Comment 4 Jens Petersen 2010-10-28 03:46:49 EDT
Latest release is now 0.3.3, do you want to update before I proceed with the review?
Comment 5 Jens Petersen 2010-10-28 03:50:25 EDT
Ah probably 0.3.3 is too new since it requires QuickCheck-2.3,
so latest version we can ship currently is 0.3.2, though
wonder if it really needs QuickCheck to build or just for tests?
Comment 6 Jens Petersen 2010-10-28 04:13:09 EDT
Also please update to latest cabal2spec.

(In reply to comment #5)
> wonder if it really needs QuickCheck to build or just for tests?

Ok sorry ignore that - seems it really is needed.
Comment 7 Jens Petersen 2010-10-28 23:11:10 EDT
You mentioned a build problem in irc:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2561729
Did you forget the hscolour buildrequires?

http://petersen.fedorapeople.org/ghc-feldspar-language.spec
builds for me just fine:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2563204
Comment 8 Shakthi Kannan 2010-10-29 03:14:47 EDT
As discussed on IRC, 0.3.2 fails to build. I will add the hscolour requirement:

%if %{with hscolour}
BuildRequires:  hscolour
%endif

to the .spec file and will upload a new package for review. Thanks!
Comment 10 Shakthi Kannan 2010-10-29 11:54:59 EDT
Posting rpmlint output:

$ rpmlint ghc-feldspar-language.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ghc-feldspar-language-0.3.1-2.fc15.src.rpm 
ghc-feldspar-language.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpmlint ghc-feldspar-language-*
ghc-feldspar-language.i686: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-feldspar-language-devel.i686: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-feldspar-language-prof.i686: E: devel-dependency ghc-feldspar-language-devel
ghc-feldspar-language-prof.i686: W: no-documentation
ghc-feldspar-language-prof.i686: W: devel-file-in-non-devel-package /usr/lib/ghc-6.12.3/feldspar-language-0.3.1/libHSfeldspar-language-0.3.1_p.a
3 packages and 0 specfiles checked; 1 errors, 4 warnings.
Comment 11 Jens Petersen 2010-11-15 04:35:00 EST
Thanks for waiting patiently.  BTW what is the roadmap
for this package are there going to be other packages in
fedora that will need it?

Here is the review:

 +:ok,  NA: not applicable

MUST Items:
[+] MUST: rpmlint output:

ghc-feldspar-language.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-feldspar-language.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-feldspar-language-devel.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-feldspar-language-prof.x86_64: E: devel-dependency ghc-feldspar-language-devel
ghc-feldspar-language-prof.x86_64: W: no-documentation
ghc-feldspar-language-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/feldspar-language-0.3.1/libHSfeldspar-language-0.3.1_p.a

These are ok.

[+] MUST: The package must be named according to the Package Naming Guidelines

Naming follows Packaging:Haskell

[+] MUST: The spec file name must match base package %{name}
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: include license files in %doc if included in source
[+] MUST: The spec file must be written in American English and be legible.
[+] MUST: source md5sum matches upstream release

4dc9ae8be2f0d20c8ba4d1b765250349  feldspar-language-0.3.1.tar.gz

[+] MUST: must successfully compile and build into binary rpms on one main arch
[+] MUST: if necessary use ExcludeArch for other archs
[+] MUST: All build dependencies must be listed in BuildRequires
[NA] MUST: use %find_lang macro for .po translations
[NA] MUST: packages with shared library files in the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[NA] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
[+] MUST: A package must own all directories that it creates, or require a package which does create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing (except license files if necessary).
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+] MUST: Each package must consistently use macros
[+] MUST: The package must contain code, or permissable content.
[NA] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[NA] MUST: Static libraries must be in a -static package.
[NA] MUST: If a package has library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[+] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[NA] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[NA] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[NA] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[NA] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Any examples or test cases for how to use this library?
Were you planning to submit feldspar-compiler too?

Package is APPROVED.
Comment 12 Jens Petersen 2010-11-15 04:37:25 EST
Created attachment 460508 [details]
ghc-feldspar-language.spec-1.patch

Minor patch to bring the spec file closer to the current cabal2spec template.
Comment 13 Shakthi Kannan 2010-11-15 11:13:55 EST
Yes, ghc-feldspar-compiler is next :) I have applied your latest patch.

SPEC: http://shakthimaan.fedorapeople.org/SPECS/ghc-feldspar-language.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/ghc-feldspar-language-0.3.1-3.fc15.src.rpm
Comment 14 Shakthi Kannan 2010-11-15 11:16:38 EST
New Package SCM Request
=======================
Package Name: ghc-feldspar-language
Short Description: Functional Embedded Language for DSP and PARallelism
Owners: shakthimaan
Branches: F-13 F-14 EL-6
InitialCC: shakthimaan
Comment 15 Jason Tibbitts 2010-11-16 08:06:02 EST
Git done (by process-git-requests).
Comment 16 Fedora Update System 2010-11-16 10:06:18 EST
ghc-feldspar-language-0.3.1-3.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/ghc-feldspar-language-0.3.1-3.fc13
Comment 17 Fedora Update System 2010-11-16 10:06:26 EST
ghc-feldspar-language-0.3.1-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/ghc-feldspar-language-0.3.1-3.fc14
Comment 18 Fedora Update System 2010-11-16 18:13:52 EST
ghc-feldspar-language-0.3.1-3.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update ghc-feldspar-language'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/ghc-feldspar-language-0.3.1-3.fc13
Comment 19 Fedora Update System 2010-11-24 17:40:27 EST
ghc-feldspar-language-0.3.1-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2010-11-24 17:45:12 EST
ghc-feldspar-language-0.3.1-3.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 21 Jens Petersen 2010-12-04 06:30:57 EST
(In reply to comment #14)
> New Package SCM Request
> =======================
> Package Name: ghc-feldspar-language
> Short Description: Functional Embedded Language for DSP and PARallelism
> Owners: shakthimaan
> Branches: F-13 F-14 EL-6
> InitialCC: shakthimaan

"InitialCC: haskell-sig" would be good.
Comment 22 Jens Petersen 2010-12-06 19:35:53 EST
> "InitialCC: haskell-sig" would be good.

added
Comment 23 Shakthi Kannan 2012-01-23 06:45:08 EST
Package Change Request
======================
Package Name: ghc-feldspar-language
New Branches: f16
Owners: shakthimaan
InitialCC: haskell-sig
Comment 24 Jon Ciesla 2012-01-23 08:02:38 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.